#pragma once
/*
*	AZN_TRunOSA.h
*
*	A class using the OSA to run AppleScripts
*	with variables from within an application
*	HEIRACHY: BASE CLASS
*	 Andrew Nemeth, Warrimoo Australia 1995
*	aznemeng@zeta.org.au
*
*	File Created:		24 Mar 95
*	File Ammended:		24, 26, 28 Mar;
*					5, 27 Apr;
*					15 May;
*					18 Oct 95.
*/


//	CLASS dec...
//
class  TRunOSA
{
//														only one per application!
	private:
		static 			ComponentInstance	scriptComponent;

	public:
		TRunOSA();
		~TRunOSA();

		OSAError			loadScript		( void );
		OSAError			loadScript		( const FSSpec & /*compiled external AppleScript file*/);

		OSAError			runScript			( void );
		OSAError			runScript			( const AEEventClass /*AESuite*/, 
											const AEEventID /*AEKind*/ );
		OSAError			runScript			( const AEEventClass /*AESuite*/, 
											const AEEventID /*AEKind*/, 
											Str255 /*Variable string*/ );

		OSAError			getResultDesc		( AEDesc * /*Result*/, long * /*Size*/ );

	private:
		AEDesc			f_aedescScript;
		OSAID			f_osaidOriginal,
						f_osaidResult;

		OSAError			myLoadScript		( Handle );
		OSAError			myRunScript		( const AEEventClass /*AESuite*/, 
											const AEEventID /*AEKind*/, 
											AEDesc * /*Variable as AEDesc*/ );

//														Prevent copy/ assign of derived classes
	private:
		TRunOSA &			operator=			( const TRunOSA & s );	//	Assignment operator
		TRunOSA( const TRunOSA & s );								//	Copy constructor
};



//	INLINE
//
inline OSAError		TRunOSA::runScript( const AEEventClass		aeclassSuite, 
									const AEEventID 		aesuiteKind )
{
	return( myRunScript( aeclassSuite, aesuiteKind, NULL ) );
}
